=== bin/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(dchroot)
add_subdirectory(dchroot-dsa)
add_subdirectory(schroot)
add_subdirectory(schroot-base)
add_subdirectory(schroot-listmounts)
add_subdirectory(schroot-mount)
