=== debian/changelog ===
schroot (1.6.13-7build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:29:04 +0200

schroot (1.6.13-7) unstable; urgency=medium

  * Team upload, debian salsa namespace.
  * Add Build-Depends: mount (Closes: #1104692)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 04 May 2025 22:07:03 +0200

schroot (1.6.13-6) unstable; urgency=low

  * Support building schroot without root. Closes: #1089426
    Thanks Niels Thykier.
  * Add pt, pt_BR and ro debconf translation.
    Closes: #1025988, #1028228, #1033713
    Thanks to the respective submitters.

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 22 Dec 2024 21:28:39 +0100

schroot (1.6.13-5) unstable; urgency=low

  * Update dependencies on obsolete packages
  * Add proposed patches to fix regressions in 1.6.13-4, thanks
    Simon McVittie. Closes: #1078539, #1079124

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 30 Aug 2024 08:32:21 +0200

schroot (1.6.13-4) unstable; urgency=medium

  * Drop duplicates in buildd configuration
  * Add French debconf translation. Closes: #1020963
  * Add Dutch debconf translation. Closes: #1021446
  * Fix example configuration. Closes: #1021780
  * Document a login shell might be switched to a regular shell
  * Cherry-pick fix for build failure with GCC-14. Closes: #1075493
  * Cherry-pick "Mount a new instance of /dev/pts in the chroot".
    Closes: #856877, #983423

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sat, 10 Aug 2024 15:23:12 +0200

schroot (1.6.13-3) unstable; urgency=medium

  * Add Spanish debconf translation. Closes: #1019483
  * Update French translation. Closes: #1020255
  * Cherry-pick "copyfiles: Replace dangling symlink during cp".
    Closes: #1020277
  * Cherry-pick copyfiles improvement from the 1.7 development branch
  * Fix variable usage in copyfiles copy_file() function

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 25 Sep 2022 20:34:42 +0200

schroot (1.6.13-2) unstable; urgency=medium

  * Add German debconf translation. Closes: #1017943
  * Cherry-pick "Replace usage of egrep and which". Closes: #1019295
  * Cherry-pick "Clean up mess created in the Portuguese
    translations". Closes: #965348 for real.

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 09 Sep 2022 19:14:33 +0200

schroot (1.6.13-1) unstable; urgency=medium

  * New upstream version 1.6.13

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Mon, 15 Aug 2022 20:54:58 +0200

schroot (1.6.12-2) unstable; urgency=high

  * Have stricter rules on chroot names. [CVE-2022-2787]

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Thu, 11 Aug 2022 21:04:10 +0200

schroot (1.6.12-1) unstable; urgency=low

  * New upstream, new upstream version
  * Ship script to sync the apt-cache between the host and chroot.
    Closes: #764785

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 22 Jul 2022 10:05:47 +0200

schroot (1.6.10-16) unstable; urgency=medium

  * Fix installation path of the service file/init script helper.
    Closes: #1012641

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sat, 11 Jun 2022 08:33:27 +0200

schroot (1.6.10-15) unstable; urgency=medium

  * Fix arch-indep build (Closes: #1012609)

 -- Jakob Haufe <sur5r@debian.org>  Fri, 10 Jun 2022 11:29:31 +0200

schroot (1.6.10-14) unstable; urgency=medium

  * Support zstd compression for file based chroots. Closes: #988274
  * Provide a proper systemd service file. Closes: #865110
  * Update Portuguese translation. Closes: #965348
  * PAM: Use common-session-noninteractive. Closes: #898949

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Thu, 09 Jun 2022 07:53:36 +0200

schroot (1.6.10-13) unstable; urgency=low

  * Take maintainership. Closes: #900874
  * Streamline patch queue
  * Forward to latest commit in upstream repo, and refresh patches.
    Closes: #763896

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 29 May 2022 18:11:18 +0200

schroot (1.6.10-12) unstable; urgency=medium

  * QA upload.
  * ensure the parent directory for binfmt-misc interpreter
    for a foreign chroot exists before using it (Closes: #983087)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 28 Feb 2021 13:43:50 +0300

schroot (1.6.10-11) unstable; urgency=medium

  * QA upload.
  * Make the build reproducible:
    - Make the documentation build reproducibly. (Closes: #902804)
    - Specify reproducible=+fixfilepath to make the binaries reproducible.

 -- Chris Lamb <lamby@debian.org>  Thu, 24 Sep 2020 10:43:32 +0100

schroot (1.6.10-10) unstable; urgency=medium

  [ Alexis Murzeau ]
  * QA upload.
  * debian/control:
    + Remove Build-Depends on deprecated dh-systemd and depend on
      debhelper (>= 9.20160709) now that it integrates dh-systemd.
      Closes: #958621.

  [ Johannes 'josch' Schauer ]
  * add debian/salsa-ci.yml

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 06 Sep 2020 16:33:58 +0200

schroot (1.6.10-9) unstable; urgency=medium

  * QA upload.
  * Source-only rebuild to allow testing migration.
  * debian/control:
    + Bump Standards-Version to 4.5.0.
    + Mark package schroot-common as Multi-Arch: foreign.

 -- Boyuan Yang <byang@debian.org>  Tue, 21 Jan 2020 12:32:05 -0500

schroot (1.6.10-8) unstable; urgency=medium

  * QA upload.
  * Fix install target to call install-arch instead of bypassing the
    various overrides (such as setting the binary suid root, and calling
    the test suite).  Closes: #948119.
  * debian/patches/zfs-snapshot-support.patch: fix the tests to match the
    implementation, overlooked due to the previous bug preventing the
    testsuite from being run during local test builds.

 -- Steve Langasek <vorlon@debian.org>  Sun, 05 Jan 2020 05:36:58 +0000

schroot (1.6.10-7) unstable; urgency=medium

  * QA upload.
  * debian/patches/zfs-snapshot-support.patch: add support for a zfs-
    snapshot backend.  Closes: #947919.

