=== debian/control ===
Source: schroot
Maintainer: Christoph Biedl <debian.axhn@manchmal.in-ulm.de>
Uploaders:
    Jakob Haufe <sur5r@debian.org>,
Homepage: https://codeberg.org/shelter/reschroot
Rules-Requires-Root: no
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/schroot
Vcs-Git: https://salsa.debian.org/debian/schroot.git
Build-Depends: debhelper-compat (= 13),
    bash-completion,
    cmake,
    fakeroot <!nocheck>,
    gettext,
    groff-base,
    libboost-dev,
    libboost-filesystem-dev,
    libboost-iostreams-dev,
    libboost-program-options-dev,
    libboost-regex-dev,
    libcppunit-dev,
    libpam0g-dev,
    mount,
    pkgconf,
    po4a,
    po-debconf,
    uuid-dev [!kfreebsd-any],
Priority: optional
Section: admin

Package: schroot-common
Architecture: all
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: common files for schroot
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 This package provides translations for localisation of schroot
 programs.

Package: schroot
Architecture: any
Pre-Depends:
    debconf,
Depends: ${misc:Depends}, ${shlibs:Depends},
    schroot-common (= ${source:Version}),
    sysvinit-utils,
Suggests:
    aufs-tools | unionfs-fuse,
    btrfs-progs,
    bzip2,
    debootstrap,
    lvm2,
    qemu-user-static,
    xz-utils,
    zfsutils-linux,
    zstd,
Enhances:
    sbuild,
Description: Execute commands in a chroot environment
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 Several different types of chroot are supported, including normal
 directories in the filesystem, and also block devices.  Sessions,
 persistent chroots created on the fly from files (tar with optional
 compression) and Btrfs, ZFS, and LVM snapshots are also supported.
 .
 schroot supports kernel personalities, allowing the programs run
 inside the chroot to have a different personality.  For example,
 running 32-bit chroots on 64-bit systems, or even running binaries
 from alternative operating systems such as SVR4 or Xenix.
 .
 schroot also integrates with sbuild, to allow building packages with
 all supported chroot types, including session-managed chroot types
 such as Btrfs, ZFS, and LVM snapshots.
 .
 schroot shares most of its options with dchroot, but offers vastly
 more functionality.
