=== debian/watch ===

version=4
opts="mode=git, gitmode=shallow, pgpmode=gittag" \
 https://codeberg.org/shelter/reschroot.git \
 refs/tags/release/reschroot-@ANY_VERSION@
